#pragma once

namespace BasicFingerPaint
{
    struct StrokeInfo
    {
        StrokeInfo() : Color(0, 0, 0),
                       Geometry(nullptr),
                       GeometryRealization(nullptr)
        {
        };

        // Copy constructor for more efficient copies of objects
        StrokeInfo(StrokeInfo && other) : 
            Points(std::move(other.Points)),
            Width(other.Width),
            Color(other.Color),
            Geometry(std::move(other.Geometry)),
            GeometryRealization(std::move(other.GeometryRealization))
        {
        }

        std::vector<D2D1_POINT_2F> Points;
        float Width;
        D2D1::ColorF Color;
        Microsoft::WRL::ComPtr<ID2D1PathGeometry> Geometry;
        Microsoft::WRL::ComPtr<ID2D1GeometryRealization> GeometryRealization;
    };
}